#ifndef __MAIN_H__
#define __MAIN_H__

#define UNICODE
#include <windows.h>
#include <stdio.h>

#define DLL_EXPORT __declspec(dllexport)

/*********************************************************/
/// Pointeur de fonction pour la callback
typedef int CALLBACK (*FSNotify_CALLBACK)(const wchar_t[]);

FSNotify_CALLBACK MonitoringCALLBACK;

/*********************************************************/

/// Handle du dossier  surveiller
HANDLE hHookFolder = NULL;

/// Structure des informations d'criture asynchrone des modification
OVERLAPPED sAsynchIO;

/// Pointeur sur le buffer FILE_NOTIFY_INFORMATION (en heap memory)
PVOID FSNotify_Buffer = NULL;

/// Taille du buffer FILE_NOTIFY_INFORMATION
DWORD FSNotify_Size;

/// Structure de notification
FILE_NOTIFY_INFORMATION *sFSNotify;

/// ID du thread GetThreadMonitoringResult()
LPDWORD ThreadID;


#ifdef __cplusplus
extern "C"
{
#endif
/*
**  Modifie le dossier  surveiller
*/
int DLL_EXPORT SetMonitoringFolder(LPCTSTR HFolderPath);

/*
**  Attend une modification et callBack
*/
int DLL_EXPORT GetMonitoringResult();

/*
**  Lance GetMonitoringResult() en boucle avec un thread (fonction non blocante)
*/
void DLL_EXPORT StartThreadMonitoring();

/*
**  Arrete le thread de GetMonitoringResult()
*/
void DLL_EXPORT StopThreadMonitoring();

/*
**  Modifie la fonction callback
*/
void DLL_EXPORT SetMonitoringCallback(FSNotify_CALLBACK CBFunction);

/*
**  Arrete la surveillance et ferme TOUT les handles
*/
void CloseMonitoring();

/*
**  Thread de surveillance
*/
DWORD WINAPI MonitoringThread(LPVOID arg);
#ifdef __cplusplus
}
#endif
#endif // __MAIN_H__
